/*
 *  simple.c
 *  22_3_06
 *
 *  Created by Simone Portuesi on 21/03/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */


/* Include GL, GLU & GLUT */
#ifdef WIN32
#include <windows.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#endif

#ifdef __APPLE__
#include <OpenGL/gl.h>
#include <OpenGL/glu.h>
#include <GLUT/glut.h>
#endif

#ifdef linux
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#endif

/* Include some standard stuff */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>

/* Include my files */
#include "main.h"
#include "TexUtils.h"

GLuint texName;

void init_model() {
   GLubyte* checkImage;
   int checkImageWidth=64;
   int checkImageHeight=64;

   /* unpack: memory -> opengl = single byte align */
   glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
  
   /* make texture */ 
   checkImage=make2DCheckImage(checkImageWidth, checkImageHeight, 8);

   /* Set texture parameters */
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
   
   /* load texture */
   glTexImage2D(GL_TEXTURE_2D, 0, GL_RGBA, checkImageWidth, checkImageHeight, 
                0, GL_RGBA, GL_UNSIGNED_BYTE, checkImage);
}

void display_model() {
   /* enagle texture, and texture draw mode */
   glEnable(GL_TEXTURE_2D);
   glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_REPLACE);

   /* Draw geometry with texture coords */
   glBegin(GL_QUADS);
   glTexCoord2f(0.0, 0.0); glVertex3f(-1.0, -1.0, 0.0);
   glTexCoord2f(0.0, 1.0); glVertex3f(1.0, -1.0, 0.0);
   glTexCoord2f(1.0, 1.0); glVertex3f(1.0, 1.0, 0.0);
   glTexCoord2f(1.0, 0.0); glVertex3f(-1.0, 1.0, 0.0);

   glTexCoord2f(0.0, 0.0); glVertex3f(-0.7071, -1, 0.7071);
   glTexCoord2f(0.0, 1.0); glVertex3f(0.7071, -1, -0.7071);
   glTexCoord2f(1.0, 1.0); glVertex3f(0.7071, 1, -0.7071);
   glTexCoord2f(1.0, 0.0); glVertex3f(-0.7071, 1, 0.7071);
   glEnd();
   
   /* Disable texture */
   glDisable(GL_TEXTURE_2D);
}

void keyboard_model(unsigned char key, int x, int y) {

}

